Loading...
Searching...
No Matches
message_strobe_random.h
Go to the documentation of this file.
/* -*- c++ -*- */
/*
* Copyright 2012-2013 Free Software Foundation, Inc.
*
* This file is part of GNU Radio
*
* SPDX-License-Identifier: GPL-3.0-or-later
*
*/
#ifndef INCLUDED_GR_MESSAGE_STROBE_RANDOM_H
#define INCLUDED_GR_MESSAGE_STROBE_RANDOM_H
#include <gnuradio/block.h>
#include <gnuradio/blocks/api.h>
namespace gr {
namespace blocks {
/*
* strobing models
*/
typedef enum {
STROBE_POISSON = 1,
STROBE_GAUSSIAN = 2,
STROBE_UNIFORM = 3,
STROBE_EXPONENTIAL = 4
} message_strobe_random_distribution_t;
/*!
* \brief Send message at defined interval
* \ingroup message_tools_blk
*
* \details
* Takes a PMT message and sends it out at random
* intervals. The interval is based on a random distribution, \p
* dist, with specified mean (\p mean_ms) and variance (\p
* std_ms). Useful for testing/debugging the message system.
*/
class BLOCKS_API message_strobe_random : virtual public block
{
public:
// gr::blocks::message_strobe_random::sptr
typedef std::shared_ptr<message_strobe_random> sptr;
/*!
* Make a message stobe block to sends message \p msg at random
* intervals defined by the distribution \p dist with mean \p
* mean_ms and standard deviation \p std_ms.
*
* \param msg The message to send as a PMT.
* \param dist The random distribution from which to draw the time between
* events.
* \param mean_ms The mean of the distribution, in milliseconds.
* \param std_ms The standard deviation of the Gaussian distribution,
* or the maximum absolute deviation of the Uniform
* distribution, in milliseconds. This argument is ignored
* for other distributions.
*/
static sptr make(pmt::pmt_t msg,
message_strobe_random_distribution_t dist,
float mean_ms,
float std_ms);
/*!
* Reset the message being sent.
* \param msg The message to send as a PMT.
*/
virtual void set_msg(pmt::pmt_t msg) = 0;
/*!
* Get the value of the message being sent.
*/
virtual pmt::pmt_t msg() const = 0;
/*!
* \param dist new distribution.
*/
virtual void set_dist(message_strobe_random_distribution_t dist) = 0;
/*!
* get the current distribution.
*/
virtual message_strobe_random_distribution_t dist() const = 0;
/*!
* Reset the sending interval.
* \param mean delay in milliseconds.
*/
virtual void set_mean(float mean) = 0;
/*!
* Get the time interval of the strobe_random.
*/
virtual float mean() const = 0;
/*!
* Reset the sending interval.
* \param std delay in milliseconds.
*/
virtual void set_std(float std) = 0;
/*!
* Get the std of strobe_random.
*/
virtual float std() const = 0;
};
} /* namespace blocks */
} /* namespace gr */
#endif /* INCLUDED_GR_MESSAGE_STROBE_H */
gr::block::block
block(void)
Definition gnuradio-runtime/include/gnuradio/block.h:806
gr::blocks::message_strobe_random
Send message at defined interval.
Definition message_strobe_random.h:42
gr::blocks::message_strobe_random::set_dist
virtual void set_dist(message_strobe_random_distribution_t dist)=0
gr::blocks::message_strobe_random::set_msg
virtual void set_msg(pmt::pmt_t msg)=0
gr::blocks::message_strobe_random::std
virtual float std() const =0
gr::blocks::message_strobe_random::msg
virtual pmt::pmt_t msg() const =0
gr::blocks::message_strobe_random::set_std
virtual void set_std(float std)=0
gr::blocks::message_strobe_random::sptr
std::shared_ptr< message_strobe_random > sptr
Definition message_strobe_random.h:45
gr::blocks::message_strobe_random::mean
virtual float mean() const =0
gr::blocks::message_strobe_random::set_mean
virtual void set_mean(float mean)=0
gr::blocks::message_strobe_random::dist
virtual message_strobe_random_distribution_t dist() const =0
gr::blocks::message_strobe_random::make
static sptr make(pmt::pmt_t msg, message_strobe_random_distribution_t dist, float mean_ms, float std_ms)
block.h
api.h
BLOCKS_API
#define BLOCKS_API
Definition gr-blocks/include/gnuradio/blocks/api.h:18
gr::blocks
Definition abs_blk.h:20
gr::blocks::message_strobe_random_distribution_t
message_strobe_random_distribution_t
Definition message_strobe_random.h:23
gr::blocks::STROBE_GAUSSIAN
@ STROBE_GAUSSIAN
Definition message_strobe_random.h:25
gr::blocks::STROBE_UNIFORM
@ STROBE_UNIFORM
Definition message_strobe_random.h:26
gr::blocks::STROBE_EXPONENTIAL
@ STROBE_EXPONENTIAL
Definition message_strobe_random.h:27
gr::blocks::STROBE_POISSON
@ STROBE_POISSON
Definition message_strobe_random.h:24
gr
GNU Radio logging wrapper.
Definition basic_block.h:29
pmt::pmt_t
std::shared_ptr< pmt_base > pmt_t
typedef for shared pointer (transparent reference counting).
Definition pmt.h:83
std
STL namespace.